; Goal of this little demo:
; (defthm rev-rev-rev
;   (equal (rev (rev (rev x)))
;          (rev x)))

(defun app (x y)
  (if (consp x)
      (cons (car x) (app (cdr x) y))
    y))

(defun rev (x)
  (if (consp x)
      (app (rev (cdr x)) (cons (car x) nil))
    nil))

; The true-listp hypothesis is necessary, and very familiar to
; ACL2 users, but we won't discuss it here.
(defthm rev-rev
  (implies (true-listp x)
           (equal (rev (rev x))
                  x)))

; Fails!
(defthm rev-rev-rev
  (equal (rev (rev (rev x)))
         (rev x)))

:brr t

:monitor (:rewrite rev-rev) t

(defthm rev-rev-rev
  (equal (rev (rev (rev x)))
         (rev x)))

:go

:eval

:abort!

:unmonitor :all

; AHA!  So, prove this:

(defthm true-listp-rev
  (true-listp (rev x)))

(defthm rev-rev-rev
  (equal (rev (rev (rev x)))
         (rev x)))

:ubt true-listp-rev

(verify ; try proof-checker instead, if time
 (equal (rev (rev (rev x)))
        (rev x)))
